
#property copyright "Yves Parent, 2008"
#property link      "www.fx-knight.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue

extern string TimeframeNote = "Must use MT4 built-in, D=1440, W=10080, M=43200";
extern int TimeFrame = 60;
extern int MaLength = 10;
extern string MaTypeNote = "0-SMA, 1-EMA, 2-SMMA, 3-LWMA";
extern int MaType = 1;
extern string MaPriceTypeNote = "0-Close, 1-Open, 2-High, 3-Low, 4-Median(H+L)/2, 5-Typical(H+L+C)/3,(H+L+C+C)/4";
extern int MaPriceType = 0;
extern bool RefreshEntireBar = TRUE;
double gda_120[];
double g_ibuf_124[];
bool gi_128 = FALSE;

int init() {
   IndicatorBuffers(2);
   SetIndexBuffer(0, g_ibuf_124);
   SetIndexStyle(0, DRAW_LINE);
   string l_str_concat_0 = StringConcatenate(TimeFrameDesc(TimeFrame), " ", MATypeDesc(MaType), "(", MaLength, ")");
   SetIndexLabel(0, l_str_concat_0);
   IndicatorShortName(l_str_concat_0);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int l_index_0;
   int l_shift_4;
   int li_12;
   int l_datetime_20;
   string ls_unused_24;
   if (gi_128) {
      l_datetime_20 = iTime(NULL, TimeFrame, 0);
      l_index_0 = 0;
      for (int l_time_16 = Time[l_index_0]; l_time_16 >= l_datetime_20; l_time_16 = Time[l_index_0]) l_index_0++;
   } else {
      li_12 = IndicatorCounted();
      if (li_12 < 0) return (-1);
      if (li_12 > 0) li_12--;
      l_index_0 = Bars - li_12;
      if (RefreshEntireBar) gi_128 = TRUE;
   }
   for (int li_8 = l_index_0; li_8 >= 0; li_8--) {
      l_shift_4 = iBarShift(Symbol(), TimeFrame, Time[li_8]);
      gda_120[li_8] = getPrice(l_shift_4);
      g_ibuf_124[li_8] = iMA(NULL, TimeFrame, MaLength, 0, MaType, MaPriceType, l_shift_4);
   }
   return (0);
}

double getPrice(int ai_0) {
   switch (MaPriceType) {
   case PRICE_CLOSE:
      return (iClose(Symbol(), TimeFrame, ai_0));
   case PRICE_OPEN:
      return (iOpen(Symbol(), TimeFrame, ai_0));
   case PRICE_HIGH:
      return (iHigh(Symbol(), TimeFrame, ai_0));
   case PRICE_LOW:
      return (iLow(Symbol(), TimeFrame, ai_0));
   case PRICE_MEDIAN:
      return ((iLow(Symbol(), TimeFrame, ai_0) + iHigh(Symbol(), TimeFrame, ai_0)) / 2.0);
   case PRICE_TYPICAL:
      return ((iClose(Symbol(), TimeFrame, ai_0) + iLow(Symbol(), TimeFrame, ai_0) + iHigh(Symbol(), TimeFrame, ai_0)) / 3.0);
   case PRICE_WEIGHTED:
      return ((iOpen(Symbol(), TimeFrame, ai_0) + iClose(Symbol(), TimeFrame, ai_0) + iLow(Symbol(), TimeFrame, ai_0) + iHigh(Symbol(), TimeFrame, ai_0)) / 4.0);
   }
   return (0.0);
}

string TimeFrameDesc(int ai_0) {
   switch (ai_0) {
   case 1:
      return ("M1");
   case 5:
      return ("M5");
   case 15:
      return ("M15");
   case 30:
      return ("M30");
   case 60:
      return ("M60");
   case 240:
      return ("H4");
   case 1440:
      return ("D");
   case 10080:
      return ("W");
   case 43200:
      return ("M");
   }
   return ("Unknown");
}

string MATypeDesc(int ai_0) {
   switch (ai_0) {
   case 0:
      return ("SMA");
   case 1:
      return ("EMA");
   case 2:
      return ("SMMA");
   case 3:
      return ("LWMA");
   }
   return ("");
}